/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32g4xx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdbool.h>
/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

void HAL_TIM_MspPostInit(TIM_HandleTypeDef *htim);

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define LED_RED_Pin GPIO_PIN_0
#define LED_RED_GPIO_Port GPIOF
#define LED_GREEN_Pin GPIO_PIN_1
#define LED_GREEN_GPIO_Port GPIOF
#define MOTOR_FAULT_Pin GPIO_PIN_0
#define MOTOR_FAULT_GPIO_Port GPIOA
#define MOTOR_SLEEP_Pin GPIO_PIN_1
#define MOTOR_SLEEP_GPIO_Port GPIOA
#define DEBUG_TX_Pin GPIO_PIN_2
#define DEBUG_TX_GPIO_Port GPIOA
#define DEBUG_RX_Pin GPIO_PIN_3
#define DEBUG_RX_GPIO_Port GPIOA
#define ML_N_Pin GPIO_PIN_4
#define ML_N_GPIO_Port GPIOA
#define IMU_RST_Pin GPIO_PIN_5
#define IMU_RST_GPIO_Port GPIOA
#define MR_N_Pin GPIO_PIN_6
#define MR_N_GPIO_Port GPIOA
#define SW2_Pin GPIO_PIN_7
#define SW2_GPIO_Port GPIOA
#define ENC_L_Pin GPIO_PIN_0
#define ENC_L_GPIO_Port GPIOB
#define ENC_L_N_Pin GPIO_PIN_8
#define ENC_L_N_GPIO_Port GPIOA
#define ROS_TX_Pin GPIO_PIN_9
#define ROS_TX_GPIO_Port GPIOA
#define ROS_RX_Pin GPIO_PIN_10
#define ROS_RX_GPIO_Port GPIOA
#define ENC_R_N_Pin GPIO_PIN_11
#define ENC_R_N_GPIO_Port GPIOA
#define ENC_R_Pin GPIO_PIN_12
#define ENC_R_GPIO_Port GPIOA
#define IMU_RX_Pin GPIO_PIN_15
#define IMU_RX_GPIO_Port GPIOA
#define IMU_TX_Pin GPIO_PIN_3
#define IMU_TX_GPIO_Port GPIOB
#define MR_P_Pin GPIO_PIN_4
#define MR_P_GPIO_Port GPIOB
#define ML_P_Pin GPIO_PIN_5
#define ML_P_GPIO_Port GPIOB
#define DEBUG_0_Pin GPIO_PIN_6
#define DEBUG_0_GPIO_Port GPIOB
/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
